# NLP in diagnostic texts from nephropathology

This python project was created as part of the article "Natural Language Processing in diagnostic texts from
nephropathology".

The paper can be found (soon) [here](LINK).

The scripts ```database_preparation/data_preparation_pipeline.py```, ```TextClustering/clustering_pipeline.py```
and ```TextClassification/classification_pipeline.py``` gives an idea of how this project can be used with other datasets.

The scripts ```TextClustering/basedOn_BOW/kmeans_Diagnosis.py```, 
```TextClustering/basedOn_BOW/HDBSCAN_Diagnosis.py``` and ```TextClassification/bow_classification.py```
can also process tf-idf vectorized corpora. 
All other scripts can only process corpora that are not vectorized.

Feel free to use and adapt the scripts to your own needs.


## Requirements

```database_preparation/preprocess.py``` requires some nltk corporas:
```
import nltk
nltk.download('stopwords')
nltk.download('punkt')
```