
#%% replace words
import re
replacement_patterns = [
    ('ittelgradig', 'äßiggradig'),
    ('ittelschwer', 'äßiggradig'),
    ('Tubulusepithelschädigung', 'Tubulusepithelschaden'),
    ('prärenalen', 'prärenale'),
    ('reversibler', 'reversibel'),
    ('max.', 'maximal'),
    ('min.', 'minimal')
]
''' ('ae', 'ä'),
    ('oe', 'ö'),
    ('ue', 'ü'),
    ('Ae', 'Ä'),
    ('Oe', 'Ö'),
    ('Ue', 'Ü'),'''

class RegexpReplacer(object):
    def __init__(self, patterns=replacement_patterns):
        self.patterns = [(re.compile(regex), repl) for (regex, repl) in
        patterns]
    def replace(self, text):
        s = text
        for (pattern, repl) in self.patterns:
            (s, count) = re.subn(pattern, repl, s)
        return s

#%% combine words
from nltk.tokenize import MWETokenizer
combinedword_patterns = [
    ('tubulointerstitieller', 'Schaden'),
     ('prärenalen', 'Genese'),
    ('prärenale', 'Genese'),
    ('potentiell', 'reversibler'),
    ('potentiell', 'reversibel'),
    ('akuter', 'Tubulusepithelschaden'),
    ('Lupus', 'Nephritis'),
    ('diabetische', 'Nephropathie'),
    ('diabetische', 'Glomerulosklerose'),
    ('0', '%'),
    ('1', '%'),
    ('2', '%'),
    ('3', '%'),
    ('4', '%'),
    ('5', '%'),
    ('6', '%'),
    ('7', '%'),
    ('8', '%'),
    ('9', '%'),
    ('tubulointerstitielle', 'Schaedigung'),
    ('segmentale', 'Glomerulosklerose'),
    ('globale', 'Glomerulosklerose'),
    ('potentiell', 'reversible'),
    ('reversible', 'Tubulusepithelschaden'),
    ('fokal', 'globale'),
    ('fokal', 'segmentale'),
    ('interstitielle', 'Nephritis'),
    ('proliferierende', 'Glomerulonephritis'),
    ('segmental', 'nekrotisierende')
]

class RegexpSynonyms(object):
    def __init__(self):
        self.patterns = combinedword_patterns

    def combine(self, text):

        mwe_tokenizer = MWETokenizer(self.patterns)
        s = mwe_tokenizer.tokenize(text)

        return s
